# uproot.source.xrootd.XRootDResource

Defined in uproot.source.xrootd on line 82.

Inheritance order:
uproot.source.chunk.Resource

class uproot.source.xrootd.XRootDResource(file_path: str, timeout: float | None)
  Parameters:

    - file_path (str) – A URL of the file to open.

    - timeout (None or float) – An optional timeout in seconds.

  A uproot.source.chunk.Resource for XRootD connections.

## timeout

XRootDResource.timeout

  The timeout in seconds or None.

## file

XRootDResource.file

  The `XRootD.client.File` object.

## num_bytes

XRootDResource.num_bytes

## closed

XRootDResource.closed

## get

XRootDResource.get(start: int, stop: int) → bytes
  Parameters:

    - start (int) – Seek position of the first byte to include.

    - stop (int) – Seek position of the first byte to exclude (one greater than the last byte to include).

  Returns a Python buffer of data between `start` and `stop`.

## future

static XRootDResource.future(source: Source, start: int, stop: int)
  Parameters:

    - source (uproot.MultithreadedXRootDSource) – The data source.

    - start (int) – Seek position of the first byte to include.

    - stop (int) – Seek position of the first byte to exclude (one greater than the last byte to include).

  Returns a uproot.source.futures.ResourceFuture that calls get with `start` and `stop`.

## partfuture

static XRootDResource.partfuture(results, start: int, stop: int)

  Returns a uproot.source.futures.ResourceFuture to simply select the `(start, stop)` item from the `results` dict.

  In chunks, each chunk has a partfuture that are collectively filled by callbacks from callbacker.

## mergefuture

static XRootDResource.mergefuture(partfutures)

  Returns a uproot.source.futures.ResourceFuture that merges the chunks previously submitted via partfuture which had to be split

## callbacker

XRootDResource.callbacker(futures, results)

  Returns an XRootD callback function to fill the `futures` and `results`.

## file_path

Inherited from uproot.source.chunk.Resource.

XRootDResource.file_path

  A path to the file (or URL).